/*
 * API League
 *
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Net.Mime;
using apileague.Client;
using apileague.Model;

namespace apileague.Api
{

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IHumorApiSync : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Generate Nonsense Word API
        /// </summary>
        /// <remarks>
        /// Generate a funny sounding nonsense word. This is useful for generating random words for games, naming things, or just for fun. The response will contain the generated word and a rating of how funny it is.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>GenerateNonsenseWordAPI200Response</returns>
        GenerateNonsenseWordAPI200Response GenerateNonsenseWordAPI(int operationIndex = 0);

        /// <summary>
        /// Generate Nonsense Word API
        /// </summary>
        /// <remarks>
        /// Generate a funny sounding nonsense word. This is useful for generating random words for games, naming things, or just for fun. The response will contain the generated word and a rating of how funny it is.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of GenerateNonsenseWordAPI200Response</returns>
        ApiResponse<GenerateNonsenseWordAPI200Response> GenerateNonsenseWordAPIWithHttpInfo(int operationIndex = 0);
        /// <summary>
        /// Random Joke API
        /// </summary>
        /// <remarks>
        /// This is a simple API that returns a random joke. You can filter the jokes by tags and keywords. To make sure they are safe for work, you could use the exclude-tags parameter to exclude jokes with certain tags such as \&quot;nsfw\&quot; or \&quot;religious\&quot;.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>SearchJokesAPI200ResponseJokesInner</returns>
        SearchJokesAPI200ResponseJokesInner RandomJokeAPI(string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), int? maxLength = default(int?), int operationIndex = 0);

        /// <summary>
        /// Random Joke API
        /// </summary>
        /// <remarks>
        /// This is a simple API that returns a random joke. You can filter the jokes by tags and keywords. To make sure they are safe for work, you could use the exclude-tags parameter to exclude jokes with certain tags such as \&quot;nsfw\&quot; or \&quot;religious\&quot;.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of SearchJokesAPI200ResponseJokesInner</returns>
        ApiResponse<SearchJokesAPI200ResponseJokesInner> RandomJokeAPIWithHttpInfo(string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), int? maxLength = default(int?), int operationIndex = 0);
        /// <summary>
        /// Random Meme API
        /// </summary>
        /// <remarks>
        /// Get a random meme out of over 300,000+ memes. To get the latest memes, you can use the max-age-days parameter.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>RandomMemeAPI200Response</returns>
        RandomMemeAPI200Response RandomMemeAPI(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int operationIndex = 0);

        /// <summary>
        /// Random Meme API
        /// </summary>
        /// <remarks>
        /// Get a random meme out of over 300,000+ memes. To get the latest memes, you can use the max-age-days parameter.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of RandomMemeAPI200Response</returns>
        ApiResponse<RandomMemeAPI200Response> RandomMemeAPIWithHttpInfo(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int operationIndex = 0);
        /// <summary>
        /// Search Gifs API
        /// </summary>
        /// <remarks>
        /// Search through hundreds of thousands of gifs to match any reaction you want. The gifs are returned in a list with the URL, width, and height of the gif.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="query">The search query.</param>
        /// <param name="number">The number of gifs to return in range [1,10] (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>SearchGifsAPI200Response</returns>
        SearchGifsAPI200Response SearchGifsAPI(string query, int? number = default(int?), int operationIndex = 0);

        /// <summary>
        /// Search Gifs API
        /// </summary>
        /// <remarks>
        /// Search through hundreds of thousands of gifs to match any reaction you want. The gifs are returned in a list with the URL, width, and height of the gif.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="query">The search query.</param>
        /// <param name="number">The number of gifs to return in range [1,10] (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of SearchGifsAPI200Response</returns>
        ApiResponse<SearchGifsAPI200Response> SearchGifsAPIWithHttpInfo(string query, int? number = default(int?), int operationIndex = 0);
        /// <summary>
        /// Search Jokes API
        /// </summary>
        /// <remarks>
        /// With over 50,000 jokes, you should find something for any occasion. There are 27 categories/tags to choose from, but you can also search for very specific words within jokes.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the joke. (optional)</param>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="offset">The number of jokes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of jokes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>SearchJokesAPI200Response</returns>
        SearchJokesAPI200Response SearchJokesAPI(string? keywords = default(string?), string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), double? maxLength = default(double?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0);

        /// <summary>
        /// Search Jokes API
        /// </summary>
        /// <remarks>
        /// With over 50,000 jokes, you should find something for any occasion. There are 27 categories/tags to choose from, but you can also search for very specific words within jokes.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the joke. (optional)</param>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="offset">The number of jokes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of jokes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of SearchJokesAPI200Response</returns>
        ApiResponse<SearchJokesAPI200Response> SearchJokesAPIWithHttpInfo(string? keywords = default(string?), string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), double? maxLength = default(double?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0);
        /// <summary>
        /// Search Memes API
        /// </summary>
        /// <remarks>
        /// Search over 300,000 memes by keyword, rating, and age. Most memes are stills (images) but using the media-type you can also get videos. You can even search for text within memes. You&#39;ll surely find something funny.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="offset">The number of memes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of memes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>SearchMemesAPI200Response</returns>
        SearchMemesAPI200Response SearchMemesAPI(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0);

        /// <summary>
        /// Search Memes API
        /// </summary>
        /// <remarks>
        /// Search over 300,000 memes by keyword, rating, and age. Most memes are stills (images) but using the media-type you can also get videos. You can even search for text within memes. You&#39;ll surely find something funny.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="offset">The number of memes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of memes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of SearchMemesAPI200Response</returns>
        ApiResponse<SearchMemesAPI200Response> SearchMemesAPIWithHttpInfo(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0);
        #endregion Synchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IHumorApiAsync : IApiAccessor
    {
        #region Asynchronous Operations
        /// <summary>
        /// Generate Nonsense Word API
        /// </summary>
        /// <remarks>
        /// Generate a funny sounding nonsense word. This is useful for generating random words for games, naming things, or just for fun. The response will contain the generated word and a rating of how funny it is.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of GenerateNonsenseWordAPI200Response</returns>
        System.Threading.Tasks.Task<GenerateNonsenseWordAPI200Response> GenerateNonsenseWordAPIAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Generate Nonsense Word API
        /// </summary>
        /// <remarks>
        /// Generate a funny sounding nonsense word. This is useful for generating random words for games, naming things, or just for fun. The response will contain the generated word and a rating of how funny it is.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (GenerateNonsenseWordAPI200Response)</returns>
        System.Threading.Tasks.Task<ApiResponse<GenerateNonsenseWordAPI200Response>> GenerateNonsenseWordAPIWithHttpInfoAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Random Joke API
        /// </summary>
        /// <remarks>
        /// This is a simple API that returns a random joke. You can filter the jokes by tags and keywords. To make sure they are safe for work, you could use the exclude-tags parameter to exclude jokes with certain tags such as \&quot;nsfw\&quot; or \&quot;religious\&quot;.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of SearchJokesAPI200ResponseJokesInner</returns>
        System.Threading.Tasks.Task<SearchJokesAPI200ResponseJokesInner> RandomJokeAPIAsync(string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), int? maxLength = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Random Joke API
        /// </summary>
        /// <remarks>
        /// This is a simple API that returns a random joke. You can filter the jokes by tags and keywords. To make sure they are safe for work, you could use the exclude-tags parameter to exclude jokes with certain tags such as \&quot;nsfw\&quot; or \&quot;religious\&quot;.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (SearchJokesAPI200ResponseJokesInner)</returns>
        System.Threading.Tasks.Task<ApiResponse<SearchJokesAPI200ResponseJokesInner>> RandomJokeAPIWithHttpInfoAsync(string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), int? maxLength = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Random Meme API
        /// </summary>
        /// <remarks>
        /// Get a random meme out of over 300,000+ memes. To get the latest memes, you can use the max-age-days parameter.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of RandomMemeAPI200Response</returns>
        System.Threading.Tasks.Task<RandomMemeAPI200Response> RandomMemeAPIAsync(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Random Meme API
        /// </summary>
        /// <remarks>
        /// Get a random meme out of over 300,000+ memes. To get the latest memes, you can use the max-age-days parameter.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (RandomMemeAPI200Response)</returns>
        System.Threading.Tasks.Task<ApiResponse<RandomMemeAPI200Response>> RandomMemeAPIWithHttpInfoAsync(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Search Gifs API
        /// </summary>
        /// <remarks>
        /// Search through hundreds of thousands of gifs to match any reaction you want. The gifs are returned in a list with the URL, width, and height of the gif.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="query">The search query.</param>
        /// <param name="number">The number of gifs to return in range [1,10] (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of SearchGifsAPI200Response</returns>
        System.Threading.Tasks.Task<SearchGifsAPI200Response> SearchGifsAPIAsync(string query, int? number = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Search Gifs API
        /// </summary>
        /// <remarks>
        /// Search through hundreds of thousands of gifs to match any reaction you want. The gifs are returned in a list with the URL, width, and height of the gif.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="query">The search query.</param>
        /// <param name="number">The number of gifs to return in range [1,10] (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (SearchGifsAPI200Response)</returns>
        System.Threading.Tasks.Task<ApiResponse<SearchGifsAPI200Response>> SearchGifsAPIWithHttpInfoAsync(string query, int? number = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Search Jokes API
        /// </summary>
        /// <remarks>
        /// With over 50,000 jokes, you should find something for any occasion. There are 27 categories/tags to choose from, but you can also search for very specific words within jokes.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the joke. (optional)</param>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="offset">The number of jokes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of jokes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of SearchJokesAPI200Response</returns>
        System.Threading.Tasks.Task<SearchJokesAPI200Response> SearchJokesAPIAsync(string? keywords = default(string?), string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), double? maxLength = default(double?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Search Jokes API
        /// </summary>
        /// <remarks>
        /// With over 50,000 jokes, you should find something for any occasion. There are 27 categories/tags to choose from, but you can also search for very specific words within jokes.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the joke. (optional)</param>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="offset">The number of jokes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of jokes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (SearchJokesAPI200Response)</returns>
        System.Threading.Tasks.Task<ApiResponse<SearchJokesAPI200Response>> SearchJokesAPIWithHttpInfoAsync(string? keywords = default(string?), string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), double? maxLength = default(double?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Search Memes API
        /// </summary>
        /// <remarks>
        /// Search over 300,000 memes by keyword, rating, and age. Most memes are stills (images) but using the media-type you can also get videos. You can even search for text within memes. You&#39;ll surely find something funny.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="offset">The number of memes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of memes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of SearchMemesAPI200Response</returns>
        System.Threading.Tasks.Task<SearchMemesAPI200Response> SearchMemesAPIAsync(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Search Memes API
        /// </summary>
        /// <remarks>
        /// Search over 300,000 memes by keyword, rating, and age. Most memes are stills (images) but using the media-type you can also get videos. You can even search for text within memes. You&#39;ll surely find something funny.
        /// </remarks>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="offset">The number of memes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of memes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (SearchMemesAPI200Response)</returns>
        System.Threading.Tasks.Task<ApiResponse<SearchMemesAPI200Response>> SearchMemesAPIWithHttpInfoAsync(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IHumorApi : IHumorApiSync, IHumorApiAsync
    {

    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class HumorApi : IHumorApi
    {
        private apileague.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="HumorApi"/> class.
        /// </summary>
        /// <returns></returns>
        public HumorApi() : this((string)null)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="HumorApi"/> class.
        /// </summary>
        /// <returns></returns>
        public HumorApi(string basePath)
        {
            this.Configuration = apileague.Client.Configuration.MergeConfigurations(
                apileague.Client.GlobalConfiguration.Instance,
                new apileague.Client.Configuration { BasePath = basePath }
            );
            this.Client = new apileague.Client.ApiClient(this.Configuration.BasePath);
            this.AsynchronousClient = new apileague.Client.ApiClient(this.Configuration.BasePath);
            this.ExceptionFactory = apileague.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="HumorApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public HumorApi(apileague.Client.Configuration configuration)
        {
            if (configuration == null) throw new ArgumentNullException("configuration");

            this.Configuration = apileague.Client.Configuration.MergeConfigurations(
                apileague.Client.GlobalConfiguration.Instance,
                configuration
            );
            this.Client = new apileague.Client.ApiClient(this.Configuration.BasePath);
            this.AsynchronousClient = new apileague.Client.ApiClient(this.Configuration.BasePath);
            ExceptionFactory = apileague.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="HumorApi"/> class
        /// using a Configuration object and client instance.
        /// </summary>
        /// <param name="client">The client interface for synchronous API access.</param>
        /// <param name="asyncClient">The client interface for asynchronous API access.</param>
        /// <param name="configuration">The configuration object.</param>
        public HumorApi(apileague.Client.ISynchronousClient client, apileague.Client.IAsynchronousClient asyncClient, apileague.Client.IReadableConfiguration configuration)
        {
            if (client == null) throw new ArgumentNullException("client");
            if (asyncClient == null) throw new ArgumentNullException("asyncClient");
            if (configuration == null) throw new ArgumentNullException("configuration");

            this.Client = client;
            this.AsynchronousClient = asyncClient;
            this.Configuration = configuration;
            this.ExceptionFactory = apileague.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// The client for accessing this underlying API asynchronously.
        /// </summary>
        public apileague.Client.IAsynchronousClient AsynchronousClient { get; set; }

        /// <summary>
        /// The client for accessing this underlying API synchronously.
        /// </summary>
        public apileague.Client.ISynchronousClient Client { get; set; }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public string GetBasePath()
        {
            return this.Configuration.BasePath;
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public apileague.Client.IReadableConfiguration Configuration { get; set; }

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public apileague.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Generate Nonsense Word API Generate a funny sounding nonsense word. This is useful for generating random words for games, naming things, or just for fun. The response will contain the generated word and a rating of how funny it is.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>GenerateNonsenseWordAPI200Response</returns>
        public GenerateNonsenseWordAPI200Response GenerateNonsenseWordAPI(int operationIndex = 0)
        {
            apileague.Client.ApiResponse<GenerateNonsenseWordAPI200Response> localVarResponse = GenerateNonsenseWordAPIWithHttpInfo();
            return localVarResponse.Data;
        }

        /// <summary>
        /// Generate Nonsense Word API Generate a funny sounding nonsense word. This is useful for generating random words for games, naming things, or just for fun. The response will contain the generated word and a rating of how funny it is.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of GenerateNonsenseWordAPI200Response</returns>
        public apileague.Client.ApiResponse<GenerateNonsenseWordAPI200Response> GenerateNonsenseWordAPIWithHttpInfo(int operationIndex = 0)
        {
            apileague.Client.RequestOptions localVarRequestOptions = new apileague.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = apileague.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = apileague.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }


            localVarRequestOptions.Operation = "HumorApi.GenerateNonsenseWordAPI";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (apiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("api-key")))
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "api-key", this.Configuration.GetApiKeyWithPrefix("api-key")));
            }
            // authentication (headerApiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<GenerateNonsenseWordAPI200Response>("/generate-nonsense-word", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GenerateNonsenseWordAPI", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Generate Nonsense Word API Generate a funny sounding nonsense word. This is useful for generating random words for games, naming things, or just for fun. The response will contain the generated word and a rating of how funny it is.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of GenerateNonsenseWordAPI200Response</returns>
        public async System.Threading.Tasks.Task<GenerateNonsenseWordAPI200Response> GenerateNonsenseWordAPIAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            apileague.Client.ApiResponse<GenerateNonsenseWordAPI200Response> localVarResponse = await GenerateNonsenseWordAPIWithHttpInfoAsync(operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Generate Nonsense Word API Generate a funny sounding nonsense word. This is useful for generating random words for games, naming things, or just for fun. The response will contain the generated word and a rating of how funny it is.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (GenerateNonsenseWordAPI200Response)</returns>
        public async System.Threading.Tasks.Task<apileague.Client.ApiResponse<GenerateNonsenseWordAPI200Response>> GenerateNonsenseWordAPIWithHttpInfoAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            apileague.Client.RequestOptions localVarRequestOptions = new apileague.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = apileague.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = apileague.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }


            localVarRequestOptions.Operation = "HumorApi.GenerateNonsenseWordAPI";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (apiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("api-key")))
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "api-key", this.Configuration.GetApiKeyWithPrefix("api-key")));
            }
            // authentication (headerApiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<GenerateNonsenseWordAPI200Response>("/generate-nonsense-word", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GenerateNonsenseWordAPI", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Random Joke API This is a simple API that returns a random joke. You can filter the jokes by tags and keywords. To make sure they are safe for work, you could use the exclude-tags parameter to exclude jokes with certain tags such as \&quot;nsfw\&quot; or \&quot;religious\&quot;.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>SearchJokesAPI200ResponseJokesInner</returns>
        public SearchJokesAPI200ResponseJokesInner RandomJokeAPI(string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), int? maxLength = default(int?), int operationIndex = 0)
        {
            apileague.Client.ApiResponse<SearchJokesAPI200ResponseJokesInner> localVarResponse = RandomJokeAPIWithHttpInfo(includeTags, excludeTags, minRating, maxLength);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Random Joke API This is a simple API that returns a random joke. You can filter the jokes by tags and keywords. To make sure they are safe for work, you could use the exclude-tags parameter to exclude jokes with certain tags such as \&quot;nsfw\&quot; or \&quot;religious\&quot;.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of SearchJokesAPI200ResponseJokesInner</returns>
        public apileague.Client.ApiResponse<SearchJokesAPI200ResponseJokesInner> RandomJokeAPIWithHttpInfo(string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), int? maxLength = default(int?), int operationIndex = 0)
        {
            apileague.Client.RequestOptions localVarRequestOptions = new apileague.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = apileague.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = apileague.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (includeTags != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "include-tags", includeTags));
            }
            if (excludeTags != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "exclude-tags", excludeTags));
            }
            if (minRating != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "min-rating", minRating));
            }
            if (maxLength != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "max-length", maxLength));
            }

            localVarRequestOptions.Operation = "HumorApi.RandomJokeAPI";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (apiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("api-key")))
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "api-key", this.Configuration.GetApiKeyWithPrefix("api-key")));
            }
            // authentication (headerApiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<SearchJokesAPI200ResponseJokesInner>("/retrieve-random-joke", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("RandomJokeAPI", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Random Joke API This is a simple API that returns a random joke. You can filter the jokes by tags and keywords. To make sure they are safe for work, you could use the exclude-tags parameter to exclude jokes with certain tags such as \&quot;nsfw\&quot; or \&quot;religious\&quot;.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of SearchJokesAPI200ResponseJokesInner</returns>
        public async System.Threading.Tasks.Task<SearchJokesAPI200ResponseJokesInner> RandomJokeAPIAsync(string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), int? maxLength = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            apileague.Client.ApiResponse<SearchJokesAPI200ResponseJokesInner> localVarResponse = await RandomJokeAPIWithHttpInfoAsync(includeTags, excludeTags, minRating, maxLength, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Random Joke API This is a simple API that returns a random joke. You can filter the jokes by tags and keywords. To make sure they are safe for work, you could use the exclude-tags parameter to exclude jokes with certain tags such as \&quot;nsfw\&quot; or \&quot;religious\&quot;.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (SearchJokesAPI200ResponseJokesInner)</returns>
        public async System.Threading.Tasks.Task<apileague.Client.ApiResponse<SearchJokesAPI200ResponseJokesInner>> RandomJokeAPIWithHttpInfoAsync(string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), int? maxLength = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            apileague.Client.RequestOptions localVarRequestOptions = new apileague.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = apileague.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = apileague.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (includeTags != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "include-tags", includeTags));
            }
            if (excludeTags != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "exclude-tags", excludeTags));
            }
            if (minRating != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "min-rating", minRating));
            }
            if (maxLength != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "max-length", maxLength));
            }

            localVarRequestOptions.Operation = "HumorApi.RandomJokeAPI";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (apiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("api-key")))
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "api-key", this.Configuration.GetApiKeyWithPrefix("api-key")));
            }
            // authentication (headerApiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<SearchJokesAPI200ResponseJokesInner>("/retrieve-random-joke", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("RandomJokeAPI", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Random Meme API Get a random meme out of over 300,000+ memes. To get the latest memes, you can use the max-age-days parameter.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>RandomMemeAPI200Response</returns>
        public RandomMemeAPI200Response RandomMemeAPI(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int operationIndex = 0)
        {
            apileague.Client.ApiResponse<RandomMemeAPI200Response> localVarResponse = RandomMemeAPIWithHttpInfo(keywords, keywordsInImage, mediaType, minRating, maxAgeDays);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Random Meme API Get a random meme out of over 300,000+ memes. To get the latest memes, you can use the max-age-days parameter.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of RandomMemeAPI200Response</returns>
        public apileague.Client.ApiResponse<RandomMemeAPI200Response> RandomMemeAPIWithHttpInfo(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int operationIndex = 0)
        {
            apileague.Client.RequestOptions localVarRequestOptions = new apileague.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = apileague.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = apileague.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (keywords != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "keywords", keywords));
            }
            if (keywordsInImage != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "keywords-in-image", keywordsInImage));
            }
            if (mediaType != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "media-type", mediaType));
            }
            if (minRating != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "min-rating", minRating));
            }
            if (maxAgeDays != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "max-age-days", maxAgeDays));
            }

            localVarRequestOptions.Operation = "HumorApi.RandomMemeAPI";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (apiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("api-key")))
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "api-key", this.Configuration.GetApiKeyWithPrefix("api-key")));
            }
            // authentication (headerApiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<RandomMemeAPI200Response>("/retrieve-random-meme", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("RandomMemeAPI", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Random Meme API Get a random meme out of over 300,000+ memes. To get the latest memes, you can use the max-age-days parameter.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of RandomMemeAPI200Response</returns>
        public async System.Threading.Tasks.Task<RandomMemeAPI200Response> RandomMemeAPIAsync(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            apileague.Client.ApiResponse<RandomMemeAPI200Response> localVarResponse = await RandomMemeAPIWithHttpInfoAsync(keywords, keywordsInImage, mediaType, minRating, maxAgeDays, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Random Meme API Get a random meme out of over 300,000+ memes. To get the latest memes, you can use the max-age-days parameter.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (RandomMemeAPI200Response)</returns>
        public async System.Threading.Tasks.Task<apileague.Client.ApiResponse<RandomMemeAPI200Response>> RandomMemeAPIWithHttpInfoAsync(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            apileague.Client.RequestOptions localVarRequestOptions = new apileague.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = apileague.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = apileague.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (keywords != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "keywords", keywords));
            }
            if (keywordsInImage != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "keywords-in-image", keywordsInImage));
            }
            if (mediaType != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "media-type", mediaType));
            }
            if (minRating != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "min-rating", minRating));
            }
            if (maxAgeDays != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "max-age-days", maxAgeDays));
            }

            localVarRequestOptions.Operation = "HumorApi.RandomMemeAPI";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (apiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("api-key")))
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "api-key", this.Configuration.GetApiKeyWithPrefix("api-key")));
            }
            // authentication (headerApiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<RandomMemeAPI200Response>("/retrieve-random-meme", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("RandomMemeAPI", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Search Gifs API Search through hundreds of thousands of gifs to match any reaction you want. The gifs are returned in a list with the URL, width, and height of the gif.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="query">The search query.</param>
        /// <param name="number">The number of gifs to return in range [1,10] (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>SearchGifsAPI200Response</returns>
        public SearchGifsAPI200Response SearchGifsAPI(string query, int? number = default(int?), int operationIndex = 0)
        {
            apileague.Client.ApiResponse<SearchGifsAPI200Response> localVarResponse = SearchGifsAPIWithHttpInfo(query, number);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Search Gifs API Search through hundreds of thousands of gifs to match any reaction you want. The gifs are returned in a list with the URL, width, and height of the gif.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="query">The search query.</param>
        /// <param name="number">The number of gifs to return in range [1,10] (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of SearchGifsAPI200Response</returns>
        public apileague.Client.ApiResponse<SearchGifsAPI200Response> SearchGifsAPIWithHttpInfo(string query, int? number = default(int?), int operationIndex = 0)
        {
            // verify the required parameter 'query' is set
            if (query == null)
            {
                throw new apileague.Client.ApiException(400, "Missing required parameter 'query' when calling HumorApi->SearchGifsAPI");
            }

            apileague.Client.RequestOptions localVarRequestOptions = new apileague.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = apileague.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = apileague.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "query", query));
            if (number != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "number", number));
            }

            localVarRequestOptions.Operation = "HumorApi.SearchGifsAPI";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (apiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("api-key")))
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "api-key", this.Configuration.GetApiKeyWithPrefix("api-key")));
            }
            // authentication (headerApiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<SearchGifsAPI200Response>("/search-gifs", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("SearchGifsAPI", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Search Gifs API Search through hundreds of thousands of gifs to match any reaction you want. The gifs are returned in a list with the URL, width, and height of the gif.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="query">The search query.</param>
        /// <param name="number">The number of gifs to return in range [1,10] (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of SearchGifsAPI200Response</returns>
        public async System.Threading.Tasks.Task<SearchGifsAPI200Response> SearchGifsAPIAsync(string query, int? number = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            apileague.Client.ApiResponse<SearchGifsAPI200Response> localVarResponse = await SearchGifsAPIWithHttpInfoAsync(query, number, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Search Gifs API Search through hundreds of thousands of gifs to match any reaction you want. The gifs are returned in a list with the URL, width, and height of the gif.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="query">The search query.</param>
        /// <param name="number">The number of gifs to return in range [1,10] (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (SearchGifsAPI200Response)</returns>
        public async System.Threading.Tasks.Task<apileague.Client.ApiResponse<SearchGifsAPI200Response>> SearchGifsAPIWithHttpInfoAsync(string query, int? number = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'query' is set
            if (query == null)
            {
                throw new apileague.Client.ApiException(400, "Missing required parameter 'query' when calling HumorApi->SearchGifsAPI");
            }


            apileague.Client.RequestOptions localVarRequestOptions = new apileague.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = apileague.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = apileague.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "query", query));
            if (number != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "number", number));
            }

            localVarRequestOptions.Operation = "HumorApi.SearchGifsAPI";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (apiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("api-key")))
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "api-key", this.Configuration.GetApiKeyWithPrefix("api-key")));
            }
            // authentication (headerApiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<SearchGifsAPI200Response>("/search-gifs", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("SearchGifsAPI", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Search Jokes API With over 50,000 jokes, you should find something for any occasion. There are 27 categories/tags to choose from, but you can also search for very specific words within jokes.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the joke. (optional)</param>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="offset">The number of jokes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of jokes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>SearchJokesAPI200Response</returns>
        public SearchJokesAPI200Response SearchJokesAPI(string? keywords = default(string?), string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), double? maxLength = default(double?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0)
        {
            apileague.Client.ApiResponse<SearchJokesAPI200Response> localVarResponse = SearchJokesAPIWithHttpInfo(keywords, includeTags, excludeTags, minRating, maxLength, offset, number);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Search Jokes API With over 50,000 jokes, you should find something for any occasion. There are 27 categories/tags to choose from, but you can also search for very specific words within jokes.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the joke. (optional)</param>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="offset">The number of jokes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of jokes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of SearchJokesAPI200Response</returns>
        public apileague.Client.ApiResponse<SearchJokesAPI200Response> SearchJokesAPIWithHttpInfo(string? keywords = default(string?), string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), double? maxLength = default(double?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0)
        {
            apileague.Client.RequestOptions localVarRequestOptions = new apileague.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = apileague.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = apileague.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (keywords != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "keywords", keywords));
            }
            if (includeTags != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "include-tags", includeTags));
            }
            if (excludeTags != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "exclude-tags", excludeTags));
            }
            if (minRating != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "min-rating", minRating));
            }
            if (maxLength != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "max-length", maxLength));
            }
            if (offset != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "offset", offset));
            }
            if (number != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "number", number));
            }

            localVarRequestOptions.Operation = "HumorApi.SearchJokesAPI";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (apiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("api-key")))
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "api-key", this.Configuration.GetApiKeyWithPrefix("api-key")));
            }
            // authentication (headerApiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<SearchJokesAPI200Response>("/search-jokes", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("SearchJokesAPI", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Search Jokes API With over 50,000 jokes, you should find something for any occasion. There are 27 categories/tags to choose from, but you can also search for very specific words within jokes.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the joke. (optional)</param>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="offset">The number of jokes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of jokes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of SearchJokesAPI200Response</returns>
        public async System.Threading.Tasks.Task<SearchJokesAPI200Response> SearchJokesAPIAsync(string? keywords = default(string?), string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), double? maxLength = default(double?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            apileague.Client.ApiResponse<SearchJokesAPI200Response> localVarResponse = await SearchJokesAPIWithHttpInfoAsync(keywords, includeTags, excludeTags, minRating, maxLength, offset, number, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Search Jokes API With over 50,000 jokes, you should find something for any occasion. There are 27 categories/tags to choose from, but you can also search for very specific words within jokes.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the joke. (optional)</param>
        /// <param name="includeTags">A comma-separated list of tags the jokes should have. (optional)</param>
        /// <param name="excludeTags">A comma-separated list of tags the jokes must not have. (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the jokes. (optional)</param>
        /// <param name="maxLength">The maximum length of the joke in letters. (optional)</param>
        /// <param name="offset">The number of jokes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of jokes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (SearchJokesAPI200Response)</returns>
        public async System.Threading.Tasks.Task<apileague.Client.ApiResponse<SearchJokesAPI200Response>> SearchJokesAPIWithHttpInfoAsync(string? keywords = default(string?), string? includeTags = default(string?), string? excludeTags = default(string?), double? minRating = default(double?), double? maxLength = default(double?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            apileague.Client.RequestOptions localVarRequestOptions = new apileague.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = apileague.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = apileague.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (keywords != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "keywords", keywords));
            }
            if (includeTags != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "include-tags", includeTags));
            }
            if (excludeTags != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "exclude-tags", excludeTags));
            }
            if (minRating != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "min-rating", minRating));
            }
            if (maxLength != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "max-length", maxLength));
            }
            if (offset != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "offset", offset));
            }
            if (number != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "number", number));
            }

            localVarRequestOptions.Operation = "HumorApi.SearchJokesAPI";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (apiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("api-key")))
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "api-key", this.Configuration.GetApiKeyWithPrefix("api-key")));
            }
            // authentication (headerApiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<SearchJokesAPI200Response>("/search-jokes", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("SearchJokesAPI", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Search Memes API Search over 300,000 memes by keyword, rating, and age. Most memes are stills (images) but using the media-type you can also get videos. You can even search for text within memes. You&#39;ll surely find something funny.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="offset">The number of memes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of memes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>SearchMemesAPI200Response</returns>
        public SearchMemesAPI200Response SearchMemesAPI(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0)
        {
            apileague.Client.ApiResponse<SearchMemesAPI200Response> localVarResponse = SearchMemesAPIWithHttpInfo(keywords, keywordsInImage, mediaType, minRating, maxAgeDays, offset, number);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Search Memes API Search over 300,000 memes by keyword, rating, and age. Most memes are stills (images) but using the media-type you can also get videos. You can even search for text within memes. You&#39;ll surely find something funny.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="offset">The number of memes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of memes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of SearchMemesAPI200Response</returns>
        public apileague.Client.ApiResponse<SearchMemesAPI200Response> SearchMemesAPIWithHttpInfo(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0)
        {
            apileague.Client.RequestOptions localVarRequestOptions = new apileague.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = apileague.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = apileague.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (keywords != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "keywords", keywords));
            }
            if (keywordsInImage != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "keywords-in-image", keywordsInImage));
            }
            if (mediaType != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "media-type", mediaType));
            }
            if (minRating != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "min-rating", minRating));
            }
            if (maxAgeDays != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "max-age-days", maxAgeDays));
            }
            if (offset != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "offset", offset));
            }
            if (number != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "number", number));
            }

            localVarRequestOptions.Operation = "HumorApi.SearchMemesAPI";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (apiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("api-key")))
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "api-key", this.Configuration.GetApiKeyWithPrefix("api-key")));
            }
            // authentication (headerApiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<SearchMemesAPI200Response>("/search-memes", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("SearchMemesAPI", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Search Memes API Search over 300,000 memes by keyword, rating, and age. Most memes are stills (images) but using the media-type you can also get videos. You can even search for text within memes. You&#39;ll surely find something funny.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="offset">The number of memes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of memes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of SearchMemesAPI200Response</returns>
        public async System.Threading.Tasks.Task<SearchMemesAPI200Response> SearchMemesAPIAsync(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            apileague.Client.ApiResponse<SearchMemesAPI200Response> localVarResponse = await SearchMemesAPIWithHttpInfoAsync(keywords, keywordsInImage, mediaType, minRating, maxAgeDays, offset, number, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Search Memes API Search over 300,000 memes by keyword, rating, and age. Most memes are stills (images) but using the media-type you can also get videos. You can even search for text within memes. You&#39;ll surely find something funny.
        /// </summary>
        /// <exception cref="apileague.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="keywords">A comma-separated list of words that must occur in the meme. (optional)</param>
        /// <param name="keywordsInImage">Whether the keywords must occur in the image. (optional)</param>
        /// <param name="mediaType">The media type (either &#39;image&#39;, &#39;video&#39; or even specific format such as &#39;jpg&#39;, &#39;png&#39;, or &#39;gif&#39;). (optional)</param>
        /// <param name="minRating">The minimum rating in range [0.0,1.0] of the meme. (optional)</param>
        /// <param name="maxAgeDays">The maximum age of the meme in days. (optional)</param>
        /// <param name="offset">The number of memes to skip, between 0 and 1000. (optional)</param>
        /// <param name="number">The number of memes, between 1 and 10. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (SearchMemesAPI200Response)</returns>
        public async System.Threading.Tasks.Task<apileague.Client.ApiResponse<SearchMemesAPI200Response>> SearchMemesAPIWithHttpInfoAsync(string? keywords = default(string?), bool? keywordsInImage = default(bool?), string? mediaType = default(string?), double? minRating = default(double?), int? maxAgeDays = default(int?), int? offset = default(int?), int? number = default(int?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            apileague.Client.RequestOptions localVarRequestOptions = new apileague.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = apileague.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = apileague.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (keywords != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "keywords", keywords));
            }
            if (keywordsInImage != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "keywords-in-image", keywordsInImage));
            }
            if (mediaType != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "media-type", mediaType));
            }
            if (minRating != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "min-rating", minRating));
            }
            if (maxAgeDays != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "max-age-days", maxAgeDays));
            }
            if (offset != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "offset", offset));
            }
            if (number != null)
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "number", number));
            }

            localVarRequestOptions.Operation = "HumorApi.SearchMemesAPI";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (apiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("api-key")))
            {
                localVarRequestOptions.QueryParameters.Add(apileague.Client.ClientUtils.ParameterToMultiMap("", "api-key", this.Configuration.GetApiKeyWithPrefix("api-key")));
            }
            // authentication (headerApiKey) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<SearchMemesAPI200Response>("/search-memes", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("SearchMemesAPI", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

    }
}
